// Type definitions for base16-js 1.0.0
// Project: https://github.com/gaearon/base16-js
// Definitions by: Alec Hill <https://github.com/alechill>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped

/**
 * Type describing a syntax highlighting scheme as a JS object, as used in redux dev tools
 * Based on https://github.com/chriskempson/base16
 */
export interface ColorScheme {
  scheme: string;
  author: string;
  base00: string;
  base01: string;
  base02: string;
  base03: string;
  base04: string;
  base05: string;
  base06: string;
  base07: string;
  base08: string;
  base09: string;
  base0A: string;
  base0B: string;
  base0C: string;
  base0D: string;
  base0E: string;
  base0F: string;
}

// predefined schemes...
export var threezerotwofour: ColorScheme;
export var apathy: ColorScheme;
export var ashes: ColorScheme;
export var atelierDune: ColorScheme;
export var atelierForest: ColorScheme;
export var atelierHeath: ColorScheme;
export var atelierLakeside: ColorScheme;
export var atelierSeaside: ColorScheme;
export var bespin: ColorScheme;
export var brewer: ColorScheme;
export var bright: ColorScheme;
export var chalk: ColorScheme;
export var codeschool: ColorScheme;
export var colors: ColorScheme;
export var eighties: ColorScheme;
export var embers: ColorScheme;
export var flat: ColorScheme;
export var google: ColorScheme;
export var grayscale: ColorScheme;
export var greenscreen: ColorScheme;
export var harmonic: ColorScheme;
export var hopscotch: ColorScheme;
export var isotope: ColorScheme;
export var marrakesh: ColorScheme;
export var monokai: ColorScheme;
export var ocean: ColorScheme;
export var paraiso: ColorScheme;
export var pop: ColorScheme;
export var railscasts: ColorScheme;
export var shapeshifter: ColorScheme;
export var solarized: ColorScheme;
export var summerfruit: ColorScheme;
export var tomorrow: ColorScheme;
export var tube: ColorScheme;
export var twilight: ColorScheme;
